﻿using System.Collections.Generic;

namespace Parade.Metadata.Asf
{
	/// <summary>
	/// 定義済みのタグに関する情報を提供します。
	/// </summary>
	public static class AsfDefinedTags
	{
		/// <summary>
		/// クラスを初期化します。
		/// </summary>
		static AsfDefinedTags()
		{
			AsfDefinedTags.AsfLeakyBucketPairs                 = new Info( "ASFLeakyBucketPairs",                 AsfTagDataType.Binary );
			AsfDefinedTags.AspectRatioX                        = new Info( "AspectRatioX",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.AspectRatioY                        = new Info( "AspectRatioY",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.Author                              = new Info( "Author",                              AsfTagDataType.String, true );
			AsfDefinedTags.AverageLevel                        = new Info( "AverageLevel",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.BannerImageData                     = new Info( "BannerImageData",                     AsfTagDataType.Binary );
			AsfDefinedTags.BannerImageType                     = new Info( "BannerImageType",                     AsfTagDataType.UInt32 );
			AsfDefinedTags.BannerImageUrl                      = new Info( "BannerImageURL",                      AsfTagDataType.String );
			AsfDefinedTags.Bitrate                             = new Info( "Bitrate",                             AsfTagDataType.UInt32 );
			AsfDefinedTags.Broadcast                           = new Info( "Broadcast",                           AsfTagDataType.Bool   );
			AsfDefinedTags.BufferAverage                       = new Info( "BufferAverage",                       AsfTagDataType.UInt32 );
			AsfDefinedTags.CanSkipBackward                     = new Info( "Can_Skip_Backward",                   AsfTagDataType.Bool   );
			AsfDefinedTags.CanSkipForward                      = new Info( "Can_Skip_Forward",                    AsfTagDataType.Bool   );
			AsfDefinedTags.Copyright                           = new Info( "Copyright",                           AsfTagDataType.String, true );
			AsfDefinedTags.CopyrightUrl                        = new Info( "CopyrightURL",                        AsfTagDataType.String );
			AsfDefinedTags.CurrentBitrate                      = new Info( "CurrentBitrate",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.Description                         = new Info( "Description",                         AsfTagDataType.String, true );
			AsfDefinedTags.DrmContentId                        = new Info( "DRM_ContentID",                       AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderContentDistributor      = new Info( "DRM_DRMHeader_ContentDistributor",    AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderContentId               = new Info( "DRM_DRMHeader_ContentID",             AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderIndividualizedVersion   = new Info( "DRM_DRMHeader_IndividualizedVersion", AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderKeyId                   = new Info( "DRM_DRMHeader_KeyID",                 AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderLicenseAcqUrl           = new Info( "DRM_DRMHeader_LicenseAcqURL",         AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeaderSubscriptionContentId   = new Info( "DRM_DRMHeader_SubscriptionContentID", AsfTagDataType.String );
			AsfDefinedTags.DrmDrmHeader                        = new Info( "DRM_DRMHeader",                       AsfTagDataType.String );
			AsfDefinedTags.DrmIndividualizedVersion            = new Info( "DRM_IndividualizedVersion",           AsfTagDataType.String );
			AsfDefinedTags.DrmKeyId                            = new Info( "DRM_KeyID",                           AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignatureCert                  = new Info( "DRM_LASignatureCert",                 AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignatureLicSrvCert            = new Info( "DRM_LASignatureLicSrvCert",           AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignaturePrivKey               = new Info( "DRM_LASignaturePrivKey",              AsfTagDataType.String );
			AsfDefinedTags.DrmLaSignatureRootCert              = new Info( "DRM_LASignatureRootCert",             AsfTagDataType.String );
			AsfDefinedTags.DrmLicenseAcqUrl                    = new Info( "DRM_LicenseAcqURL",                   AsfTagDataType.String );
			AsfDefinedTags.DrmLicenseId                        = new Info( "DRM_LicenseID",                       AsfTagDataType.String );
			AsfDefinedTags.DrmSourceId                         = new Info( "DRM_SourceID",                        AsfTagDataType.UInt32 );
			AsfDefinedTags.DrmV1LicenseAcqUrl                  = new Info( "DRM_V1LicenseAcqURL",                 AsfTagDataType.String );
			AsfDefinedTags.Duration                            = new Info( "Duration",                            AsfTagDataType.UInt64 );
			AsfDefinedTags.FileSize                            = new Info( "FileSize",                            AsfTagDataType.UInt64 );
			AsfDefinedTags.HasArbitraryDataStream              = new Info( "HasArbitraryDataStream",              AsfTagDataType.Bool   );
			AsfDefinedTags.HasAttachedImages                   = new Info( "HasAttachedImages",                   AsfTagDataType.Bool   );
			AsfDefinedTags.HasAudio                            = new Info( "HasAudio",                            AsfTagDataType.Bool   );
			AsfDefinedTags.HasFileTransferStream               = new Info( "HasFileTransferStream",               AsfTagDataType.Bool   );
			AsfDefinedTags.HasImage                            = new Info( "HasImage",                            AsfTagDataType.Bool   );
			AsfDefinedTags.HasScript                           = new Info( "HasScript",                           AsfTagDataType.Bool   );
			AsfDefinedTags.HasVideo                            = new Info( "HasVideo",                            AsfTagDataType.Bool   );
			AsfDefinedTags.IsProtected                         = new Info( "Is_Protected",                        AsfTagDataType.Bool   );
			AsfDefinedTags.IsTrusted                           = new Info( "Is_Trusted",                          AsfTagDataType.Bool   );
			AsfDefinedTags.Isan                                = new Info( "ISAN",                                AsfTagDataType.String );
			AsfDefinedTags.IsVBR                               = new Info( "IsVBR",                               AsfTagDataType.Bool   );
			AsfDefinedTags.NscAddress                          = new Info( "NSC_Address",                         AsfTagDataType.String );
			AsfDefinedTags.NscDescription                      = new Info( "NSC_Description",                     AsfTagDataType.String );
			AsfDefinedTags.NscEmail                            = new Info( "NSC_Email",                           AsfTagDataType.String );
			AsfDefinedTags.NscName                             = new Info( "NSC_Name",                            AsfTagDataType.String );
			AsfDefinedTags.NscPhone                            = new Info( "NSC_Phone",                           AsfTagDataType.String );
			AsfDefinedTags.NumberOfFrames                      = new Info( "NumberOfFrames",                      AsfTagDataType.UInt64 );
			AsfDefinedTags.OptimalBitrate                      = new Info( "OptimalBitrate",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.PeakValue                           = new Info( "PeakValue",                           AsfTagDataType.UInt32 );
			AsfDefinedTags.Rating                              = new Info( "Rating",                              AsfTagDataType.String, true );
			AsfDefinedTags.Seekable                            = new Info( "Seekable",                            AsfTagDataType.Bool   );
			AsfDefinedTags.Signature_Name                      = new Info( "Signature_Name",                      AsfTagDataType.String );
			AsfDefinedTags.Stridable                           = new Info( "Stridable",                           AsfTagDataType.Bool   );
			AsfDefinedTags.Title                               = new Info( "Title",                               AsfTagDataType.String, true );
			AsfDefinedTags.VbrPeak                             = new Info( "VBRPeak",                             AsfTagDataType.UInt32 );
			AsfDefinedTags.WmAlbumArtist                       = new Info( "WM/AlbumArtist",                      AsfTagDataType.String, true );
			AsfDefinedTags.WmAlbumCoverUrl                     = new Info( "WM/AlbumCoverURL",                    AsfTagDataType.String );
			AsfDefinedTags.WmAlbumTitle                        = new Info( "WM/AlbumTitle",                       AsfTagDataType.String, true );
			AsfDefinedTags.WmAsfPacketCount                    = new Info( "WM/ASFPacketCount",                   AsfTagDataType.UInt64 );
			AsfDefinedTags.WmAsfSecurityObjectsSize            = new Info( "WM/ASFSecurityObjectsSize",           AsfTagDataType.UInt64 );
			AsfDefinedTags.WmAudioFileUrl                      = new Info( "WM/AudioFileURL",                     AsfTagDataType.String );
			AsfDefinedTags.WmAudioSourceUrl                    = new Info( "WM/AudioSourceURL",                   AsfTagDataType.String );
			AsfDefinedTags.WmAuthorUrl                         = new Info( "WM/AuthorURL",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmBeatsPerMinute                    = new Info( "WM/BeatsPerMinute",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmCategory                          = new Info( "WM/Category",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmCodec                             = new Info( "WM/Codec",                            AsfTagDataType.String );
			AsfDefinedTags.WmComposer                          = new Info( "WM/Composer",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmConductor                         = new Info( "WM/Conductor",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmContainerFormat                   = new Info( "WM/ContainerFormat",                  AsfTagDataType.Binary );
			AsfDefinedTags.WmContentDistributor                = new Info( "WM/ContentDistributor",               AsfTagDataType.String );
			AsfDefinedTags.WmContentGroupDescription           = new Info( "WM/ContentGroupDescription",          AsfTagDataType.String, true );
			AsfDefinedTags.WmDirector                          = new Info( "WM/Director",                         AsfTagDataType.String );
			AsfDefinedTags.WmDrm                               = new Info( "WM/DRM",                              AsfTagDataType.String );
			AsfDefinedTags.WmDvdId                             = new Info( "WM/DVDID",                            AsfTagDataType.String );
			AsfDefinedTags.WmEncodedBy                         = new Info( "WM/EncodedBy",                        AsfTagDataType.String );
			AsfDefinedTags.WmEncodingSettings                  = new Info( "WM/EncodingSettings",                 AsfTagDataType.String );
			AsfDefinedTags.WmEncodingTime                      = new Info( "WM/EncodingTime",                     AsfTagDataType.UInt64 );
			AsfDefinedTags.WmGenre                             = new Info( "WM/Genre",                            AsfTagDataType.String, true );
			AsfDefinedTags.WmGenreId                           = new Info( "WM/GenreID",                          AsfTagDataType.String, true );
			AsfDefinedTags.WmInitialKey                        = new Info( "WM/InitialKey",                       AsfTagDataType.String, true );
			AsfDefinedTags.WmIsrc                              = new Info( "WM/ISRC",                             AsfTagDataType.String );
			AsfDefinedTags.WmLanguage                          = new Info( "WM/Language",                         AsfTagDataType.String );
			AsfDefinedTags.WmLyrics                            = new Info( "WM/Lyrics",                           AsfTagDataType.String );
			AsfDefinedTags.WmLyricsSynchronised                = new Info( "WM/Lyrics_Synchronised",              AsfTagDataType.Binary );
			AsfDefinedTags.WmMCDI                              = new Info( "WM/MCDI",                             AsfTagDataType.Binary );
			AsfDefinedTags.WmMediaClassPrimaryId               = new Info( "WM/MediaClassPrimaryID",              AsfTagDataType.Guid   );
			AsfDefinedTags.WmMediaClassSecondaryId             = new Info( "WM/MediaClassSecondaryID",            AsfTagDataType.Guid   );
			AsfDefinedTags.WmMediaCredits                      = new Info( "WM/MediaCredits",                     AsfTagDataType.String );
			AsfDefinedTags.WmMediaIsDelay                      = new Info( "WM/MediaIsDelay",                     AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsFinale                     = new Info( "WM/MediaIsFinale",                    AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsLive                       = new Info( "WM/MediaIsLive",                      AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsPremiere                   = new Info( "WM/MediaIsPremiere",                  AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsRepeat                     = new Info( "WM/MediaIsRepeat",                    AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsSap                        = new Info( "WM/MediaIsSAP",                       AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsStereo                     = new Info( "WM/MediaIsStereo",                    AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsSubtitled                  = new Info( "WM/MediaIsSubtitled",                 AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaIsTape                       = new Info( "WM/MediaIsTape",                      AsfTagDataType.Bool   );
			AsfDefinedTags.WmMediaNetworkAffiliation           = new Info( "WM/MediaNetworkAffiliation",          AsfTagDataType.String );
			AsfDefinedTags.WmMediaOriginalBroadcastDateTime    = new Info( "WM/MediaOriginalBroadcastDateTime",   AsfTagDataType.String );
			AsfDefinedTags.WmMediaOriginalChannel              = new Info( "WM/MediaOriginalChannel",             AsfTagDataType.String );
			AsfDefinedTags.WmMediaStationCallSign              = new Info( "WM/MediaStationCallSign",             AsfTagDataType.String );
			AsfDefinedTags.WmMediaStationName                  = new Info( "WM/MediaStationName",                 AsfTagDataType.String );
			AsfDefinedTags.WmModifiedBy                        = new Info( "WM/ModifiedBy",                       AsfTagDataType.String );
			AsfDefinedTags.WmMood                              = new Info( "WM/Mood",                             AsfTagDataType.String, true );
			AsfDefinedTags.WmOriginalAlbumTitle                = new Info( "WM/OriginalAlbumTitle",               AsfTagDataType.String );
			AsfDefinedTags.WmOriginalArtist                    = new Info( "WM/OriginalArtist",                   AsfTagDataType.String );
			AsfDefinedTags.WmOriginalFilename                  = new Info( "WM/OriginalFilename",                 AsfTagDataType.String );
			AsfDefinedTags.WmOriginalLyricist                  = new Info( "WM/OriginalLyricist",                 AsfTagDataType.String );
			AsfDefinedTags.WmOriginalReleaseTime               = new Info( "WM/OriginalReleaseTime",              AsfTagDataType.String );
			AsfDefinedTags.WmOriginalReleaseYear               = new Info( "WM/OriginalReleaseYear",              AsfTagDataType.String );
			AsfDefinedTags.WmParentalRating                    = new Info( "WM/ParentalRating",                   AsfTagDataType.String, true );
			AsfDefinedTags.WmParentalRatingReason              = new Info( "WM/ParentalRatingReason",             AsfTagDataType.String );
			AsfDefinedTags.WmPartOfSet                         = new Info( "WM/PartOfSet",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmPeakBitrate                       = new Info( "WM/PeakBitrate",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.WmPeriod                            = new Info( "WM/Period",                           AsfTagDataType.String, true );
			AsfDefinedTags.WmPicture                           = new Info( "WM/Picture",                          AsfTagDataType.Binary );
			AsfDefinedTags.WmPlaylistDelay                     = new Info( "WM/PlaylistDelay",                    AsfTagDataType.String );
			AsfDefinedTags.WmProducer                          = new Info( "WM/Producer",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmPromotionUrl                      = new Info( "WM/PromotionURL",                     AsfTagDataType.String, true );
			AsfDefinedTags.WmProtectionType                    = new Info( "WM/ProtectionType",                   AsfTagDataType.String );
			AsfDefinedTags.WmProvider                          = new Info( "WM/Provider",                         AsfTagDataType.String );
			AsfDefinedTags.WmProviderCopyright                 = new Info( "WM/ProviderCopyright",                AsfTagDataType.String );
			AsfDefinedTags.WmProviderRating                    = new Info( "WM/ProviderRating",                   AsfTagDataType.String );
			AsfDefinedTags.WmProviderStyle                     = new Info( "WM/ProviderStyle",                    AsfTagDataType.String );
			AsfDefinedTags.WmPublisher                         = new Info( "WM/Publisher",                        AsfTagDataType.String, true );
			AsfDefinedTags.WmRadioStationName                  = new Info( "WM/RadioStationName",                 AsfTagDataType.String );
			AsfDefinedTags.WmRadioStationOwner                 = new Info( "WM/RadioStationOwner",                AsfTagDataType.String );
			AsfDefinedTags.WmSharedUserRating                  = new Info( "WM/SharedUserRating",                 AsfTagDataType.UInt32 );
			AsfDefinedTags.WmStreamTypeInfo                    = new Info( "WM/StreamTypeInfo",                   AsfTagDataType.Binary );
			AsfDefinedTags.WmSubscriptionContentId             = new Info( "WM/SubscriptionContentID",            AsfTagDataType.String );
			AsfDefinedTags.WmSubTitle                          = new Info( "WM/SubTitle",                         AsfTagDataType.String, true );
			AsfDefinedTags.WmSubTitleDescription               = new Info( "WM/SubTitleDescription",              AsfTagDataType.String );
			AsfDefinedTags.WmText                              = new Info( "WM/Text",                             AsfTagDataType.Binary );
			AsfDefinedTags.WmToolName                          = new Info( "WM/ToolName",                         AsfTagDataType.String );
			AsfDefinedTags.WmToolVersion                       = new Info( "WM/ToolVersion",                      AsfTagDataType.String );
			AsfDefinedTags.WmTrack                             = new Info( "WM/Track",                            AsfTagDataType.String, true );
			AsfDefinedTags.WmTrackNumber                       = new Info( "WM/TrackNumber",                      AsfTagDataType.String, true );
			AsfDefinedTags.WmUniqueFileIdentifier              = new Info( "WM/UniqueFileIdentifier",             AsfTagDataType.String );
			AsfDefinedTags.WmUserWebUrl                        = new Info( "WM/UserWebURL",                       AsfTagDataType.Binary );
			AsfDefinedTags.WmVideoClosedCaptioning             = new Info( "WM/VideoClosedCaptioning",            AsfTagDataType.Bool   );
			AsfDefinedTags.WmVideoFrameRate                    = new Info( "WM/VideoFrameRate",                   AsfTagDataType.UInt32 );
			AsfDefinedTags.WmVideoHeight                       = new Info( "WM/VideoHeight",                      AsfTagDataType.UInt32 );
			AsfDefinedTags.WmVideoWidth                        = new Info( "WM/VideoWidth",                       AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmaDRCAverageReference            = new Info( "WM/WMADRCAverageReference",           AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmaDRCAverageTarget               = new Info( "WM/WMADRCAverageTarget",              AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmaDRCPeakReference               = new Info( "WM/WMADRCPeakReference",              AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmaDRCPeakTarget                  = new Info( "WM/WMADRCPeakTarget",                 AsfTagDataType.UInt32 );
			AsfDefinedTags.WmWmCollectionGroupId               = new Info( "WM/WMCollectionGroupID",              AsfTagDataType.Guid   );
			AsfDefinedTags.WmWmCollectionId                    = new Info( "WM/WMCollectionID",                   AsfTagDataType.Guid   );
			AsfDefinedTags.WmWmContentId                       = new Info( "WM/WMContentID",                      AsfTagDataType.Guid   );
			AsfDefinedTags.WmWmShadowFileSourceDrmType         = new Info( "WM/WMShadowFileSourceDRMType",        AsfTagDataType.String );
			AsfDefinedTags.WmWmShadowFileSourceFileType        = new Info( "WM/WMShadowFileSourceFileType",       AsfTagDataType.String );
			AsfDefinedTags.WmWriter                            = new Info( "WM/Writer",                           AsfTagDataType.String, true );
			AsfDefinedTags.WmYear                              = new Info( "WM/Year",                             AsfTagDataType.String, true );

			AsfDefinedTags.Infos = new Dictionary< string, Info >()
			{
				{ AsfDefinedTags.AsfLeakyBucketPairs.Name,               AsfDefinedTags.AsfLeakyBucketPairs               },
				{ AsfDefinedTags.AspectRatioX.Name,                      AsfDefinedTags.AspectRatioX                      },
				{ AsfDefinedTags.AspectRatioY.Name,                      AsfDefinedTags.AspectRatioY                      },
				{ AsfDefinedTags.Author.Name,                            AsfDefinedTags.Author                            },
				{ AsfDefinedTags.AverageLevel.Name,                      AsfDefinedTags.AverageLevel                      },
				{ AsfDefinedTags.BannerImageData.Name,                   AsfDefinedTags.BannerImageData                   },
				{ AsfDefinedTags.BannerImageType.Name,                   AsfDefinedTags.BannerImageType                   },
				{ AsfDefinedTags.BannerImageUrl.Name,                    AsfDefinedTags.BannerImageUrl                    },
				{ AsfDefinedTags.Bitrate.Name,                           AsfDefinedTags.Bitrate                           },
				{ AsfDefinedTags.Broadcast.Name,                         AsfDefinedTags.Broadcast                         },
				{ AsfDefinedTags.BufferAverage.Name,                     AsfDefinedTags.BufferAverage                     },
				{ AsfDefinedTags.CanSkipBackward.Name,                   AsfDefinedTags.CanSkipBackward                   },
				{ AsfDefinedTags.CanSkipForward.Name,                    AsfDefinedTags.CanSkipForward                    },
				{ AsfDefinedTags.Copyright.Name,                         AsfDefinedTags.Copyright                         },
				{ AsfDefinedTags.CopyrightUrl.Name,                      AsfDefinedTags.CopyrightUrl                      },
				{ AsfDefinedTags.CurrentBitrate.Name,                    AsfDefinedTags.CurrentBitrate                    },
				{ AsfDefinedTags.Description.Name,                       AsfDefinedTags.Description                       },
				{ AsfDefinedTags.DrmContentId.Name,                      AsfDefinedTags.DrmContentId                      },
				{ AsfDefinedTags.DrmDrmHeaderContentDistributor.Name,    AsfDefinedTags.DrmDrmHeaderContentDistributor    },
				{ AsfDefinedTags.DrmDrmHeaderContentId.Name,             AsfDefinedTags.DrmDrmHeaderContentId             },
				{ AsfDefinedTags.DrmDrmHeaderIndividualizedVersion.Name, AsfDefinedTags.DrmDrmHeaderIndividualizedVersion },
				{ AsfDefinedTags.DrmDrmHeaderKeyId.Name,                 AsfDefinedTags.DrmDrmHeaderKeyId                 },
				{ AsfDefinedTags.DrmDrmHeaderLicenseAcqUrl.Name,         AsfDefinedTags.DrmDrmHeaderLicenseAcqUrl         },
				{ AsfDefinedTags.DrmDrmHeaderSubscriptionContentId.Name, AsfDefinedTags.DrmDrmHeaderSubscriptionContentId },
				{ AsfDefinedTags.DrmDrmHeader.Name,                      AsfDefinedTags.DrmDrmHeader                      },
				{ AsfDefinedTags.DrmIndividualizedVersion.Name,          AsfDefinedTags.DrmIndividualizedVersion          },
				{ AsfDefinedTags.DrmKeyId.Name,                          AsfDefinedTags.DrmKeyId                          },
				{ AsfDefinedTags.DrmLaSignatureCert.Name,                AsfDefinedTags.DrmLaSignatureCert                },
				{ AsfDefinedTags.DrmLaSignatureLicSrvCert.Name,          AsfDefinedTags.DrmLaSignatureLicSrvCert          },
				{ AsfDefinedTags.DrmLaSignaturePrivKey.Name,             AsfDefinedTags.DrmLaSignaturePrivKey             },
				{ AsfDefinedTags.DrmLaSignatureRootCert.Name,            AsfDefinedTags.DrmLaSignatureRootCert            },
				{ AsfDefinedTags.DrmLicenseAcqUrl.Name,                  AsfDefinedTags.DrmLicenseAcqUrl                  },
				{ AsfDefinedTags.DrmLicenseId.Name,                      AsfDefinedTags.DrmLicenseId                      },
				{ AsfDefinedTags.DrmSourceId.Name,                       AsfDefinedTags.DrmSourceId                       },
				{ AsfDefinedTags.DrmV1LicenseAcqUrl.Name,                AsfDefinedTags.DrmV1LicenseAcqUrl                },
				{ AsfDefinedTags.Duration.Name,                          AsfDefinedTags.Duration                          },
				{ AsfDefinedTags.FileSize.Name,                          AsfDefinedTags.FileSize                          },
				{ AsfDefinedTags.HasArbitraryDataStream.Name,            AsfDefinedTags.HasArbitraryDataStream            },
				{ AsfDefinedTags.HasAttachedImages.Name,                 AsfDefinedTags.HasAttachedImages                 },
				{ AsfDefinedTags.HasAudio.Name,                          AsfDefinedTags.HasAudio                          },
				{ AsfDefinedTags.HasFileTransferStream.Name,             AsfDefinedTags.HasFileTransferStream             },
				{ AsfDefinedTags.HasImage.Name,                          AsfDefinedTags.HasImage                          },
				{ AsfDefinedTags.HasScript.Name,                         AsfDefinedTags.HasScript                         },
				{ AsfDefinedTags.HasVideo.Name,                          AsfDefinedTags.HasVideo                          },
				{ AsfDefinedTags.IsProtected.Name,                       AsfDefinedTags.IsProtected                       },
				{ AsfDefinedTags.IsTrusted.Name,                         AsfDefinedTags.IsTrusted                         },
				{ AsfDefinedTags.Isan.Name,                              AsfDefinedTags.Isan                              },
				{ AsfDefinedTags.IsVBR.Name,                             AsfDefinedTags.IsVBR                             },
				{ AsfDefinedTags.NscAddress.Name,                        AsfDefinedTags.NscAddress                        },
				{ AsfDefinedTags.NscDescription.Name,                    AsfDefinedTags.NscDescription                    },
				{ AsfDefinedTags.NscEmail.Name,                          AsfDefinedTags.NscEmail                          },
				{ AsfDefinedTags.NscName.Name,                           AsfDefinedTags.NscName                           },
				{ AsfDefinedTags.NscPhone.Name,                          AsfDefinedTags.NscPhone                          },
				{ AsfDefinedTags.NumberOfFrames.Name,                    AsfDefinedTags.NumberOfFrames                    },
				{ AsfDefinedTags.OptimalBitrate.Name,                    AsfDefinedTags.OptimalBitrate                    },
				{ AsfDefinedTags.PeakValue.Name,                         AsfDefinedTags.PeakValue                         },
				{ AsfDefinedTags.Rating.Name,                            AsfDefinedTags.Rating                            },
				{ AsfDefinedTags.Seekable.Name,                          AsfDefinedTags.Seekable                          },
				{ AsfDefinedTags.Signature_Name.Name,                    AsfDefinedTags.Signature_Name                    },
				{ AsfDefinedTags.Stridable.Name,                         AsfDefinedTags.Stridable                         },
				{ AsfDefinedTags.Title.Name,                             AsfDefinedTags.Title                             },
				{ AsfDefinedTags.VbrPeak.Name,                           AsfDefinedTags.VbrPeak                           },
				{ AsfDefinedTags.WmAlbumArtist.Name,                     AsfDefinedTags.WmAlbumArtist                     },
				{ AsfDefinedTags.WmAlbumCoverUrl.Name,                   AsfDefinedTags.WmAlbumCoverUrl                   },
				{ AsfDefinedTags.WmAlbumTitle.Name,                      AsfDefinedTags.WmAlbumTitle                      },
				{ AsfDefinedTags.WmAsfPacketCount.Name,                  AsfDefinedTags.WmAsfPacketCount                  },
				{ AsfDefinedTags.WmAsfSecurityObjectsSize.Name,          AsfDefinedTags.WmAsfSecurityObjectsSize          },
				{ AsfDefinedTags.WmAudioFileUrl.Name,                    AsfDefinedTags.WmAudioFileUrl                    },
				{ AsfDefinedTags.WmAudioSourceUrl.Name,                  AsfDefinedTags.WmAudioSourceUrl                  },
				{ AsfDefinedTags.WmAuthorUrl.Name,                       AsfDefinedTags.WmAuthorUrl                       },
				{ AsfDefinedTags.WmBeatsPerMinute.Name,                  AsfDefinedTags.WmBeatsPerMinute                  },
				{ AsfDefinedTags.WmCategory.Name,                        AsfDefinedTags.WmCategory                        },
				{ AsfDefinedTags.WmCodec.Name,                           AsfDefinedTags.WmCodec                           },
				{ AsfDefinedTags.WmComposer.Name,                        AsfDefinedTags.WmComposer                        },
				{ AsfDefinedTags.WmConductor.Name,                       AsfDefinedTags.WmConductor                       },
				{ AsfDefinedTags.WmContainerFormat.Name,                 AsfDefinedTags.WmContainerFormat                 },
				{ AsfDefinedTags.WmContentDistributor.Name,              AsfDefinedTags.WmContentDistributor              },
				{ AsfDefinedTags.WmContentGroupDescription.Name,         AsfDefinedTags.WmContentGroupDescription         },
				{ AsfDefinedTags.WmDirector.Name,                        AsfDefinedTags.WmDirector                        },
				{ AsfDefinedTags.WmDrm.Name,                             AsfDefinedTags.WmDrm                             },
				{ AsfDefinedTags.WmDvdId.Name,                           AsfDefinedTags.WmDvdId                           },
				{ AsfDefinedTags.WmEncodedBy.Name,                       AsfDefinedTags.WmEncodedBy                       },
				{ AsfDefinedTags.WmEncodingSettings.Name,                AsfDefinedTags.WmEncodingSettings                },
				{ AsfDefinedTags.WmEncodingTime.Name,                    AsfDefinedTags.WmEncodingTime                    },
				{ AsfDefinedTags.WmGenre.Name,                           AsfDefinedTags.WmGenre                           },
				{ AsfDefinedTags.WmGenreId.Name,                         AsfDefinedTags.WmGenreId                         },
				{ AsfDefinedTags.WmInitialKey.Name,                      AsfDefinedTags.WmInitialKey                      },
				{ AsfDefinedTags.WmIsrc.Name,                            AsfDefinedTags.WmIsrc                            },
				{ AsfDefinedTags.WmLanguage.Name,                        AsfDefinedTags.WmLanguage                        },
				{ AsfDefinedTags.WmLyrics.Name,                          AsfDefinedTags.WmLyrics                          },
				{ AsfDefinedTags.WmLyricsSynchronised.Name,              AsfDefinedTags.WmLyricsSynchronised              },
				{ AsfDefinedTags.WmMCDI.Name,                            AsfDefinedTags.WmMCDI                            },
				{ AsfDefinedTags.WmMediaClassPrimaryId.Name,             AsfDefinedTags.WmMediaClassPrimaryId             },
				{ AsfDefinedTags.WmMediaClassSecondaryId.Name,           AsfDefinedTags.WmMediaClassSecondaryId           },
				{ AsfDefinedTags.WmMediaCredits.Name,                    AsfDefinedTags.WmMediaCredits                    },
				{ AsfDefinedTags.WmMediaIsDelay.Name,                    AsfDefinedTags.WmMediaIsDelay                    },
				{ AsfDefinedTags.WmMediaIsFinale.Name,                   AsfDefinedTags.WmMediaIsFinale                   },
				{ AsfDefinedTags.WmMediaIsLive.Name,                     AsfDefinedTags.WmMediaIsLive                     },
				{ AsfDefinedTags.WmMediaIsPremiere.Name,                 AsfDefinedTags.WmMediaIsPremiere                 },
				{ AsfDefinedTags.WmMediaIsRepeat.Name,                   AsfDefinedTags.WmMediaIsRepeat                   },
				{ AsfDefinedTags.WmMediaIsSap.Name,                      AsfDefinedTags.WmMediaIsSap                      },
				{ AsfDefinedTags.WmMediaIsStereo.Name,                   AsfDefinedTags.WmMediaIsStereo                   },
				{ AsfDefinedTags.WmMediaIsSubtitled.Name,                AsfDefinedTags.WmMediaIsSubtitled                },
				{ AsfDefinedTags.WmMediaIsTape.Name,                     AsfDefinedTags.WmMediaIsTape                     },
				{ AsfDefinedTags.WmMediaNetworkAffiliation.Name,         AsfDefinedTags.WmMediaNetworkAffiliation         },
				{ AsfDefinedTags.WmMediaOriginalBroadcastDateTime.Name,  AsfDefinedTags.WmMediaOriginalBroadcastDateTime  },
				{ AsfDefinedTags.WmMediaOriginalChannel.Name,            AsfDefinedTags.WmMediaOriginalChannel            },
				{ AsfDefinedTags.WmMediaStationCallSign.Name,            AsfDefinedTags.WmMediaStationCallSign            },
				{ AsfDefinedTags.WmMediaStationName.Name,                AsfDefinedTags.WmMediaStationName                },
				{ AsfDefinedTags.WmModifiedBy.Name,                      AsfDefinedTags.WmModifiedBy                      },
				{ AsfDefinedTags.WmMood.Name,                            AsfDefinedTags.WmMood                            },
				{ AsfDefinedTags.WmOriginalAlbumTitle.Name,              AsfDefinedTags.WmOriginalAlbumTitle              },
				{ AsfDefinedTags.WmOriginalArtist.Name,                  AsfDefinedTags.WmOriginalArtist                  },
				{ AsfDefinedTags.WmOriginalFilename.Name,                AsfDefinedTags.WmOriginalFilename                },
				{ AsfDefinedTags.WmOriginalLyricist.Name,                AsfDefinedTags.WmOriginalLyricist                },
				{ AsfDefinedTags.WmOriginalReleaseTime.Name,             AsfDefinedTags.WmOriginalReleaseTime             },
				{ AsfDefinedTags.WmOriginalReleaseYear.Name,             AsfDefinedTags.WmOriginalReleaseYear             },
				{ AsfDefinedTags.WmParentalRating.Name,                  AsfDefinedTags.WmParentalRating                  },
				{ AsfDefinedTags.WmParentalRatingReason.Name,            AsfDefinedTags.WmParentalRatingReason            },
				{ AsfDefinedTags.WmPartOfSet.Name,                       AsfDefinedTags.WmPartOfSet                       },
				{ AsfDefinedTags.WmPeakBitrate.Name,                     AsfDefinedTags.WmPeakBitrate                     },
				{ AsfDefinedTags.WmPeriod.Name,                          AsfDefinedTags.WmPeriod                          },
				{ AsfDefinedTags.WmPicture.Name,                         AsfDefinedTags.WmPicture                         },
				{ AsfDefinedTags.WmPlaylistDelay.Name,                   AsfDefinedTags.WmPlaylistDelay                   },
				{ AsfDefinedTags.WmProducer.Name,                        AsfDefinedTags.WmProducer                        },
				{ AsfDefinedTags.WmPromotionUrl.Name,                    AsfDefinedTags.WmPromotionUrl                    },
				{ AsfDefinedTags.WmProtectionType.Name,                  AsfDefinedTags.WmProtectionType                  },
				{ AsfDefinedTags.WmProvider.Name,                        AsfDefinedTags.WmProvider                        },
				{ AsfDefinedTags.WmProviderCopyright.Name,               AsfDefinedTags.WmProviderCopyright               },
				{ AsfDefinedTags.WmProviderRating.Name,                  AsfDefinedTags.WmProviderRating                  },
				{ AsfDefinedTags.WmProviderStyle.Name,                   AsfDefinedTags.WmProviderStyle                   },
				{ AsfDefinedTags.WmPublisher.Name,                       AsfDefinedTags.WmPublisher                       },
				{ AsfDefinedTags.WmRadioStationName.Name,                AsfDefinedTags.WmRadioStationName                },
				{ AsfDefinedTags.WmRadioStationOwner.Name,               AsfDefinedTags.WmRadioStationOwner               },
				{ AsfDefinedTags.WmSharedUserRating.Name,                AsfDefinedTags.WmSharedUserRating                },
				{ AsfDefinedTags.WmStreamTypeInfo.Name,                  AsfDefinedTags.WmStreamTypeInfo                  },
				{ AsfDefinedTags.WmSubscriptionContentId.Name,           AsfDefinedTags.WmSubscriptionContentId           },
				{ AsfDefinedTags.WmSubTitle.Name,                        AsfDefinedTags.WmSubTitle                        },
				{ AsfDefinedTags.WmSubTitleDescription.Name,             AsfDefinedTags.WmSubTitleDescription             },
				{ AsfDefinedTags.WmText.Name,                            AsfDefinedTags.WmText                            },
				{ AsfDefinedTags.WmToolName.Name,                        AsfDefinedTags.WmToolName                        },
				{ AsfDefinedTags.WmToolVersion.Name,                     AsfDefinedTags.WmToolVersion                     },
				{ AsfDefinedTags.WmTrack.Name,                           AsfDefinedTags.WmTrack                           },
				{ AsfDefinedTags.WmTrackNumber.Name,                     AsfDefinedTags.WmTrackNumber                     },
				{ AsfDefinedTags.WmUniqueFileIdentifier.Name,            AsfDefinedTags.WmUniqueFileIdentifier            },
				{ AsfDefinedTags.WmUserWebUrl.Name,                      AsfDefinedTags.WmUserWebUrl                      },
				{ AsfDefinedTags.WmVideoClosedCaptioning.Name,           AsfDefinedTags.WmVideoClosedCaptioning           },
				{ AsfDefinedTags.WmVideoFrameRate.Name,                  AsfDefinedTags.WmVideoFrameRate                  },
				{ AsfDefinedTags.WmVideoHeight.Name,                     AsfDefinedTags.WmVideoHeight                     },
				{ AsfDefinedTags.WmVideoWidth.Name,                      AsfDefinedTags.WmVideoWidth                      },
				{ AsfDefinedTags.WmWmaDRCAverageReference.Name,          AsfDefinedTags.WmWmaDRCAverageReference          },
				{ AsfDefinedTags.WmWmaDRCAverageTarget.Name,             AsfDefinedTags.WmWmaDRCAverageTarget             },
				{ AsfDefinedTags.WmWmaDRCPeakReference.Name,             AsfDefinedTags.WmWmaDRCPeakReference             },
				{ AsfDefinedTags.WmWmaDRCPeakTarget.Name,                AsfDefinedTags.WmWmaDRCPeakTarget                },
				{ AsfDefinedTags.WmWmCollectionGroupId.Name,             AsfDefinedTags.WmWmCollectionGroupId             },
				{ AsfDefinedTags.WmWmCollectionId.Name,                  AsfDefinedTags.WmWmCollectionId                  },
				{ AsfDefinedTags.WmWmContentId.Name,                     AsfDefinedTags.WmWmContentId                     },
				{ AsfDefinedTags.WmWmShadowFileSourceDrmType.Name,       AsfDefinedTags.WmWmShadowFileSourceDrmType       },
				{ AsfDefinedTags.WmWmShadowFileSourceFileType.Name,      AsfDefinedTags.WmWmShadowFileSourceFileType      },
				{ AsfDefinedTags.WmWriter.Name,                          AsfDefinedTags.WmWriter                          },
				{ AsfDefinedTags.WmYear.Name,                            AsfDefinedTags.WmYear                            }
			};
		}

		/// <summary>
		/// 指定された名前を持つタグ情報を取得します。
		/// </summary>
		/// <param name="name">名前。</param>
		/// <returns>成功時はタグ情報。それ以外は null 参照。</returns>
		public static Info GetInfo( string name )
		{
			Info info;
			return ( AsfDefinedTags.Infos.TryGetValue( name, out info ) ? info : null );
		}

		/// <summary>
		/// タグ名のコレクションを取得します。
		/// </summary>
		/// <returns>タグ名のコレクション。</returns>
		public static IEnumerable< string > GetNames()
		{
			return AsfDefinedTags.Infos.Keys;
		}

		/// <summary>
		/// 指定された名前を持つタグが定義されていることを調べます。
		/// </summary>
		/// <param name="name">名前。</param>
		/// <returns>定義されている場合は true。それ以外は false。</returns>
		public static bool HasInfo( string name )
		{
			return AsfDefinedTags.Infos.ContainsKey( name );
		}

		/// <summary>
		/// 
		/// </summary>
		public static Info AsfLeakyBucketPairs { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info AspectRatioX { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info AspectRatioY { get; private set; }

		/// <summary>
		/// アーティストを示すタグ定義を取得します。
		/// </summary>
		public static Info Author { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info AverageLevel { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info BannerImageData { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info BannerImageType { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info BannerImageUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info Bitrate { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info Broadcast { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info BufferAverage { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info CanSkipBackward { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info CanSkipForward { get; private set; }

		/// <summary>
		/// 著作権情報を示すタグ定義を取得します。
		/// </summary>
		public static Info Copyright { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info CopyrightUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info CurrentBitrate { get; private set; }

		/// <summary>
		/// コメントを示すタグ定義を取得します。
		/// </summary>
		public static Info Description { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeaderContentDistributor { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeaderContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeaderIndividualizedVersion { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeaderKeyId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeaderLicenseAcqUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeaderSubscriptionContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmDrmHeader { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmIndividualizedVersion { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmKeyId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmLaSignatureCert { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmLaSignatureLicSrvCert { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmLaSignaturePrivKey { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmLaSignatureRootCert { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmLicenseAcqUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmLicenseId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmSourceId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info DrmV1LicenseAcqUrl { get; private set; }

		/// <summary>
		/// 演奏時間を示すタグ定義を取得します。
		/// </summary>
		public static Info Duration { get; private set; }

		/// <summary>
		/// ファイルサイズを示すタグ定義を取得します。
		/// </summary>
		public static Info FileSize { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasArbitraryDataStream { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasAttachedImages { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasAudio { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasFileTransferStream { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasImage { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasScript { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info HasVideo { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info IsProtected { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info IsTrusted { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info Isan { get; private set; }

		/// <summary>
		/// 可変ビットレートでエンコードされたことを示すタグ定義を取得します。
		/// </summary>
		public static Info IsVBR { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info NscAddress { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info NscDescription { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info NscEmail { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info NscName { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info NscPhone { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info NumberOfFrames { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info OptimalBitrate { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info PeakValue { get; private set; }

		/// <summary>
		/// 保護者による制限を示すタグ定義を取得します。
		/// </summary>
		public static Info Rating { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info Seekable { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info Signature_Name { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info Stridable { get; private set; }

		/// <summary>
		/// タイトルを示すタグ定義を取得します。
		/// </summary>
		public static Info Title { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info VbrPeak { get; private set; }

		/// <summary>
		/// アルバムのアーティスト名を示すタグ定義を取得します。
		/// </summary>
		public static Info WmAlbumArtist { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmAlbumCoverUrl { get; private set; }

		/// <summary>
		/// アルバム名を示すタグ定義を取得します。
		/// </summary>
		public static Info WmAlbumTitle { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmAsfPacketCount { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmAsfSecurityObjectsSize { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmAudioFileUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmAudioSourceUrl { get; private set; }

		/// <summary>
		/// アーティストの URL を示すタグ定義を取得します。
		/// </summary>
		public static Info WmAuthorUrl { get; private set; }

		/// <summary>
		/// テンポ ( 1 分間の拍数 ) を示すタグ定義を取得します。
		/// </summary>
		public static Info WmBeatsPerMinute { get; private set; }

		/// <summary>
		/// カテゴリを示すタグ定義を取得します。
		/// </summary>
		public static Info WmCategory { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmCodec { get; private set; }

		/// <summary>
		/// 作曲者を示すタグ定義を取得します。
		/// </summary>
		public static Info WmComposer { get; private set; }

		/// <summary>
		/// 指揮者を示すタグ定義を取得します。
		/// </summary>
		public static Info WmConductor { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmContainerFormat { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmContentDistributor { get; private set; }

		/// <summary>
		/// グループの説明を示すタグ定義を取得します。
		/// </summary>
		public static Info WmContentGroupDescription { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmDirector { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmDrm { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmDvdId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmEncodedBy { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmEncodingSettings { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmEncodingTime { get; private set; }

		/// <summary>
		/// ジャンルを示すタグ定義を取得します。
		/// </summary>
		public static Info WmGenre { get; private set; }

		/// <summary>
		/// ジャンル ID を示すタグ定義を取得します。
		/// この情報は ID3v2 の TCON タグに準拠しています。
		/// 通常、"(17) Rock" のように、括弧にジャンルを表す数値を入れ、後続の文字列にジャンル名を格納します。
		/// 詳細は ID3v2 の仕様を参照してください。
		/// </summary>
		public static Info WmGenreId { get; private set; }

		/// <summary>
		/// 曲頭のキー ( C、Am、F♯ といった調の文字列 ) を示すタグ定義を取得します。
		/// </summary>
		public static Info WmInitialKey { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmIsrc { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmLanguage { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmLyrics { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmLyricsSynchronised { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMCDI { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaClassPrimaryId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaClassSecondaryId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaCredits { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsDelay { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsFinale { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsLive { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsPremiere { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsRepeat { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsSap { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsStereo { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsSubtitled { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaIsTape { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaNetworkAffiliation { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaOriginalBroadcastDateTime { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaOriginalChannel { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaStationCallSign { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmMediaStationName { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmModifiedBy { get; private set; }

		/// <summary>
		/// 曲の雰囲気を示すタグ定義を取得します。
		/// </summary>
		public static Info WmMood { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmOriginalAlbumTitle { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmOriginalArtist { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmOriginalFilename { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmOriginalLyricist { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmOriginalReleaseTime { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmOriginalReleaseYear { get; private set; }

		/// <summary>
		/// 保護者による制限を示すタグ定義を取得します。
		/// </summary>
		public static Info WmParentalRating { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmParentalRatingReason { get; private set; }

		/// <summary>
		/// 曲の属するグループ内の番号 ( スラッシュ区切りの文字列 ) を示すタグ定義を取得します。
		/// 複数枚や複数の組曲で構成されるアルバムの場合、それらの総数と何番目に位置するかを表します。
		/// 例えば 3 枚組のアルバムにおいて、2 枚目に属する曲ならば "2/3" となります。
		/// </summary>
		public static Info WmPartOfSet { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmPeakBitrate { get; private set; }

		/// <summary>
		/// 音楽の年代を示すタグ定義を取得します。
		/// 例えばバロックやルネッサンスなど、ある時代を指すために使用します。
		/// </summary>
		public static Info WmPeriod { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmPicture { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmPlaylistDelay { get; private set; }

		/// <summary>
		/// プロデューサーを示すタグ定義を取得します。
		/// </summary>
		public static Info WmProducer { get; private set; }

		/// <summary>
		/// プロモーション用の URL を示すタグ定義を取得します。
		/// </summary>
		public static Info WmPromotionUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmProtectionType { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmProvider { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmProviderCopyright { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmProviderRating { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmProviderStyle { get; private set; }

		/// <summary>
		/// 曲の発行元 ( レーベル ) を示すタグ定義を取得します。
		/// </summary>
		public static Info WmPublisher { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmRadioStationName { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmRadioStationOwner { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmSharedUserRating { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmStreamTypeInfo { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmSubscriptionContentId { get; private set; }

		/// <summary>
		/// 副題を示すタグ定義を取得します。
		/// </summary>
		public static Info WmSubTitle { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmSubTitleDescription { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmText { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmToolName { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmToolVersion { get; private set; }

		/// <summary>
		/// トラック番号 ( 0 から開始 ) を示すタグ定義を取得します。
		/// このデータは下位互換のために残されており、現在は WmTrackNumber を代りに使用します。
		/// </summary>
		public static Info WmTrack { get; private set; }

		/// <summary>
		/// トラック番号 ( 1 から開始 ) を示すタグ定義を取得します。
		/// </summary>
		public static Info WmTrackNumber { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmUniqueFileIdentifier { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmUserWebUrl { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmVideoClosedCaptioning { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmVideoFrameRate { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmVideoHeight { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmVideoWidth { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmaDRCAverageReference { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmaDRCAverageTarget { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmaDRCPeakReference { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmaDRCPeakTarget { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmCollectionGroupId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmCollectionId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmContentId { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmShadowFileSourceDrmType { get; private set; }

		/// <summary>
		/// 
		/// </summary>
		public static Info WmWmShadowFileSourceFileType { get; private set; }

		/// <summary>
		/// 作詞者を示すタグ定義を取得します。
		/// </summary>
		public static Info WmWriter { get; private set; }

		/// <summary>
		/// リリースされた年を示すタグ定義を取得します。
		/// </summary>
		public static Info WmYear { get; private set; }

		/// <summary>
		/// タグ名をキーとするタグ情報のディクショナリ。
		/// </summary>
		private static Dictionary< string, Info > Infos;

		/// <summary>
		/// タグの基本情報を表します。
		/// </summary>
		public class Info
		{
			/// <summary>
			/// インスタンスを初期化します。
			/// </summary>
			/// <param name="name">名前。</param>
			/// <param name="type">データ型。</param>
			/// <param name="canEdit">編集可能な値ならば true。それ以外は false。</param>
			internal Info( string name, AsfTagDataType type, bool canEdit )
			{
				this.Name = name;
				this.Type = type;
				this.CanEdit = canEdit;
			}

			/// <summary>
			/// インスタンスを初期化します。
			/// </summary>
			/// <param name="name">名前。</param>
			/// <param name="type">データ型。</param>
			internal Info( string name, AsfTagDataType type )
				: this( name, type, false )
			{
			}

			/// <summary>
			/// 編集可能であることを示す値を取得します。
			/// </summary>
			public bool CanEdit { get; private set; }

			/// <summary>
			/// 名前を取得します。
			/// </summary>
			public string Name { get; private set; }

			/// <summary>
			/// データ型を取得します。
			/// </summary>
			public AsfTagDataType Type { get; private set; }
		}
	}
}
